<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<style>
    .picture-cover{
        background-image: url("cover.jpg");
        min-height: 100px;
    }
</style>
<body>
    <div class="header container-fluid">
        <div class="picture-cover">
        </div>
    </div>
    <div class="container">
        <div class="row">
            <div class="col-sm-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label for="">Username</label>
                    </div>
                    <div class="col-8">
                        <input type="text" id="inp-userName">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label for="">Firstname</label>
                    </div>
                    <div class="col-8">
                        <input type="text" name="" id="inp-firstName">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label for="">Lastname</label>
                    </div>
                    <div class="col-8">
                       <input type="text" id="inp-lastName">
                    </div>
                </div>
            </div>
            <div class="col-sm-4 text-center ">
                <div class="row form-group">
                    <div class="col-12">
                        <input type="button" class="btn btn-success button-width w-75" value="Ném" onclick="onBtnNemClick()">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12 " >
                        <img src="dice.png" alt="" class="w-100 img-thumbnail" id="img-dice">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12 ">
                        <p id="p-hienThi">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-sm-3 text-center">
                <div class="row form-group">
                    <div class="col-12 ">
                        <p id="p-voucher1">Voucher</p>
                        <p id="p-voucher2">ID </p>
                        <p id="p-voucher3">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12 ">
                        <img src="no-present.jpg" alt="" class="img-thumbnail w-100" id="img-prize">
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group">
            <div class="row text-center">
                <div class="col-12">
                    <input type="button" value="Dice History" class="btn btn-primary button-width w-25">
                    <input type="button" value="Voucher History" class="btn btn-primary button-width w-25">
                    <input type="button" value="Present History" class="btn btn-primary button-width w-25">
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12 ">
                <table class="table table-striped table-hover border">
                    <tbody>
                        <tr>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </tr>
                        <tr>
                            <td>1</td>
                            <td>2</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnNemClick()
    {
        playerObj = {
            firstname: "",
            lastname: "",
            username: ""
        };
        docDuLieuTuForm(playerObj);
        var vDuLieuHopLe = kiemTraDuLieu(playerObj);
        if(vDuLieuHopLe)
        {
            onBtnGetNewDiceClick(playerObj);
        }
    }
    
/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function docDuLieuTuForm(paramPlayerObj)
    {
        vUserName = document.getElementById("inp-userName");
        vFirstName = document.getElementById("inp-firstName");
        vLastName = document.getElementById("inp-lastName");
        paramPlayerObj.username = vUserName.value.trim();
        paramPlayerObj.firstname = vFirstName.value.trim();
        paramPlayerObj.lastname = vLastName.value.trim();
    }
    function kiemTraDuLieu(paramPlayerObj)
    {
        if(paramPlayerObj.username=="")
        {
            alert("Cần nhập user name!");
            return false;
        }
        if(paramPlayerObj.firstname=="")
        {
            alert("Cần nhập fist name!");
            return false;
        }
        if(paramPlayerObj.lastname=="")
        {
            alert("Cần nhập last name!");
            return false;
        }
        return true;
    }
    function onBtnGetNewDiceClick(paramPlayerObj) {
        //base url
        const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
        const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";

        // create a request
        var vXmlHttpDice = new XMLHttpRequest();
        vXmlHttpDice.open("POST", vBASE_URL + "/dice", true);
        vXmlHttpDice.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        vXmlHttpDice.send(JSON.stringify(paramPlayerObj));  //chuyển Json object sang string

        vXmlHttpDice.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                console.log(vXmlHttpDice.responseText);
                var vResponse = JSON.parse(vXmlHttpDice.responseText);
                console.log(vResponse);
                hienThiKetQuaCHoi(vResponse);
            }
        }
    }
    function hienThiKetQuaCHoi(paramResponse)
    {
        var vUrlAnh = paramResponse.dice + ".png";
         changeContentTagImg(vUrlAnh);
        if(paramResponse.dice<=3)
        {
            changeContentTagP("Chúc mừng bạn may mắn lần sau !!!");
            
        }
        else
        {
            changeContentTagP("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
        }
        changeContentVoucher(paramResponse.voucher);
        changeContentPrize(paramResponse.prize);
    }
    function changeContentTagP(paramText)
    {
        var vP = document.getElementById("p-hienThi");
        vP.innerHTML = paramText;
    }   
    function changeContentTagImg(paramUrl)
    {
        var vImg = document.getElementById("img-dice");
        vImg.src = paramUrl;
    }  
    function changeContentVoucher(paramVoucher)
    {
        if(paramVoucher!=null)
        {
            var vPVoucher2 = document.getElementById("p-voucher2");
            var vPVoucher3= document.getElementById("p-voucher3");
            vPVoucher2.innerHTML = paramVoucher.maVoucher;
            vPVoucher3.innerHTML = paramVoucher.phanTramGiamGia + "%";
        }
    } 
    function changeContentPrize(paramPrize)
    {
        if(paramPrize!=null)
        {
            var vImg = document.getElementById("img-prize");
            vImg.src = "car.jpg";
        }
    }

</script>
</html>